<?php

/* 
 * Hi-Level wrapper for Ares API
 */

require_once 'ares_api.php';
require_once 'messages.php';
require_once 'commpass_reg_screen.php';
require_once 'commpass_utils.php';

class AresApiWrapper {

    private static $mac;
    
    public static function Call($method, &$plugin_cookies, $args = array())
    {
        if(!self::$mac) self::$mac = get_mac_address();
        $api = new AresApi(CommpassConfig::API_URL, self::$mac, $plugin_cookies);
        
        try
        {
            if(isset($plugin_cookies->username) && isset($plugin_cookies->password))
            {
                hd_print("Trying to register terminal with username='" . 
                        $plugin_cookies->username . "', password='" . $plugin_cookies->password . "'");
                $api->register_terminal(array(
                    'username'  => $plugin_cookies->username,
                    'password'  => $plugin_cookies->password
                ));
                
                unset($plugin_cookies->username);
                unset($plugin_cookies->password);
                unset($plugin_cookies->session_id);
                hd_print("registration succeed");
            }
            
            if(!isset($plugin_cookies->session_id))
                $api->login();
            try
            {
                return $api->$method($args);
            } 
            catch (MwAuthException $ex) 
            {
                // may be session expired
                $api->login(); 
                return $api->$method($args);
            }
            
        }
        catch(MwAuthException $ex)
        {
            throw new ShowRegistrationScreenException();
        }
        catch(MwBlockedException $ex)
        {
            throw new ShowErrorMessageException('Доступ заблокирован', $ex->getMessage());
        }
        catch(AresApiException $ex)
        {
            throw new DuneException($ex->getMessage(), $ex->getCode(), 
                    ActionFactory::show_error(
                            true, 
                            'Ошибка соединения с сервером', 
                            array('Не удалось подключиться к серверу Middleware',
                                'Пожалуйста, проверьте подключение к сети и ',
                                'перезапустите плагин. Если ошибка повторится',
                                'пожалкйста, обратитесь в службу технической ',
                                'поддержки'),
                            null
                    )
            );
        }
        
    }
}

