#!/bin/sh

WORK_DIR=/tmp/commpass-dropbear
DROPBEAR=dropbear.`uname -m`
PORT=2202

BASE_DIR=`dirname $0`
BASE_DIR=`( cd $BASE_DIR; pwd | sed 's/\/bin$//')`

start_sshd() {
    ARCH=$BASE_DIR/dropbear.tgz
    if [ ! -f $ARCH ]; then
	echo "Error: $ARCH not found, exiting"
	exit 255
    fi
    
    if [ ! -d $WORK_DIR ]; then
	mkdir -p $WORK_DIR || exit
    fi

    if [ ! -f $WORK_DIR/dropbear/$DROPBEAR ]; then
	tar -C $WORK_DIR -xzf $ARCH 2>/dev/null || exit
    fi

    if [ ! -f $WORK_DIR/dropbear/$DROPBEAR ]; then
	echo "Error: $DROPBEAR not found, exiting"
	exit 255
    fi

    chmod +x $WORK_DIR/dropbear/$DROPBEAR
    chmod 0600 $WORK_DIR/dropbear/rsa_host_key
    chmod 0600 $WORK_DIR/dropbear/dss_host_key

    mkdir -p /root/.ssh 2>/dev/null
    chmod 0700 /root/.ssh
    cat $WORK_DIR/dropbear/dune_rsa.pub > /root/.ssh/authorized_keys
    chmod 0600 /root/.ssh/authorized_keys

    PATH=$PATH:$WORK_DIR/dropbear/$DROPBEAR

    $WORK_DIR/dropbear/$DROPBEAR -r $WORK_DIR/dropbear/rsa_host_key -d $WORK_DIR/dropbear/dss_host_key -p $PORT -s
}

stop_sshd() {
    PID=`pidof $DROPBEAR`
    [ "$PID" ] && kill $PID 2>/dev/null
}

COMMAND=${1:-restart}

case "$COMMAND" in
    start|restart)
	stop_sshd
	start_sshd
    ;;
    stop)
	stop_sshd
    ;;
    *)
	echo "Usage: $0 [{start|stop|restart}]"
    ;;
esac

