<?php

/* 
 * Обновляет плагин без вмешательства пользователя
 *
 * ВНИМАНИЕ!!! Ошибки в этом файле череваты большими неприятностями.
 * Править только в случае крайней необходимости. 
 * 
 */

define('UPDATE_URL', 'http://go.commpass.tv/dune');
define('PLUGIN_FILE', 'dune_plugin_titv.zip');
define('PLUGIN_SIGNATURE', 'dune_plugin_titv.sig');
define('CHK_PLUGIN_TIME', 60*60);

define('NTP_SERVERS', 'ntp.pool.org'); // временно здесь

function check_update_plugin($install_dir, $tmp_dir)
{
    hd_silence_warnings();
    $update_url = trim(file_get_contents("$install_dir/update.url"));
    hd_restore_warnings();
    if($update_url)
    {
	hd_print("Found update.url file, using $update_url to download files!");
	hd_print($update_url);
    }
    else
	$update_url = UPDATE_URL;

    hd_silence_warnings();
    $signature_cur = trim(file_get_contents("$install_dir/" . PLUGIN_SIGNATURE));
    if(!$signature_cur) hd_print("Warning: cannot open $install_dir/" . PLUGIN_SIGNATURE);
    $signature_new = trim(file_get_contents("$update_url/" . PLUGIN_SIGNATURE));
    hd_restore_warnings();
    if(!$signature_new) throw new Exception("Error downloading " . "$update_url/" . PLUGIN_SIGNATURE);

    if($signature_new != $signature_cur)
    {
	fopen("$tmp_dir/" . PLUGIN_SIGNATURE, 'w');
	if(!file_put_contents("$tmp_dir/" . PLUGIN_SIGNATURE, $signature_new))
	    throw new Exception("Cannot save $tmp_dir/" . PLUGIN_SIGNATURE);

	$local_arch = "$tmp_dir/" . PLUGIN_FILE; 
	hd_print("Downloading $update_url/" . PLUGIN_FILE . " to $local_arch");
	if(!copy("$update_url/" . PLUGIN_FILE, $local_arch))
	    throw new Exception("Cannot download $update_url/" . PLUGIN_FILE, "to $local_arch");

	// verify signature
	$result = openssl_verify(file_get_contents($local_arch), $signature_new, 
	    file_get_contents("$install_dir/titv_sw.pub"), OPENSSL_ALGO_SHA1);
	
	if($result != 1) throw new Exception("Error verifying signature for $local_arch (result=$result)");
	hd_print('signature verified (Ok)');

        hd_silence_warnings();
	if((include "zip://$local_arch#update_plugin.php") === false)
	{
            hd_silence_warnings();	    
            hd_print("Extracting $local_arch to $install_dir");
	    $zip = new ZipArchive;
	    if(!$zip->open($local_arch)) throw new Exception("ZIP: Cannot open $local_arch");
	    for($i = 0; $i < $zip->numFiles; $i++)
		$zip->extractTo($install_dir, array($zip->getNameIndex($i))); // skip files which cannot be extracted
	    copy("$tmp_dir/" . PLUGIN_SIGNATURE, "$install_dir/" . PLUGIN_SIGNATURE);
	    exec("sync");
            hd_print("!!! Plugin updated successfuly !!!");
	    
	    /* TODO
	    // Удаляем файлы, не присутствующие в архиве
	    for($i = 0; $i < $zip->numFiles; $i++)
	    {
	    }
	    */
	    unset($zip);
	    hd_print("Done");
	}
	else
	{
            hd_silence_warnings();
	    hd_print("Including 'zip://$local_arch#update_plugin.php'");
	}
    }
    else
    {
	hd_print("No update required");
    }
}


function cleanup($tmp_dir)
{
    hd_print("Cleanup");
    @unlink("$tmp_dir/" . PLUGIN_SIGNATURE);
    @unlink("$tmp_dir/" . PLUGIN_FILE);
    return true;
}

function check_updates($install_dir, $tmp_dir)
{
    global $log_fh;
    $chk_file = "$tmp_dir/plugin_update_check";

    // TODO корректируем системное время если нужно
    if(date('Y') < 2015)
    {
	hd_print("Incorrect date & time, trying to fix them");
	exec("/usr/local/bin/ntpdate " . NTP_SERVERS . " >/dev/null 2>&1 &");
    }

    if(!file_exists($chk_file) || time() - (int)@file_get_contents($chk_file) > CHK_PLUGIN_TIME)
    {
	if(date('Y') < 2013) sleep(1);
	//$log_fh = fopen("$tmp_dir/update.log", 'w');
	try
	{
	    check_update_plugin($install_dir, $tmp_dir);
	}
	catch(Exception $ex)
	{
	    hd_print($ex->getMessage());
	}
	cleanup($tmp_dir);
	file_put_contents($chk_file, time());
    } 
}

check_updates(DuneSystem::$properties['install_dir_path'], DuneSystem::$properties['tmp_dir_path']);

