<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/tv/default_channel.php';
require_once 'url.php';

///////////////////////////////////////////////////////////////////////////

class CommpassChannel extends DefaultChannel
{
    private $number;
    private $past_epg_days;
    private $future_epg_days;
    private $age_limit;
    private $archive_past_sec;
    private $archive_delay_sec;
    private $is_protected;

    ///////////////////////////////////////////////////////////////////////

    public function __construct(
        $id, $title, $icon_url, $streaming_url, $archive_url, $number, $past_epg_days, $future_epg_days, 
            $archive_past_sec, $archive_delay_sec, $age_limit = 0, $is_protected = false)
    {
        parent::__construct($id, $title, $icon_url, $streaming_url);

        $this->number = $number;
        $this->past_epg_days = $past_epg_days;
        $this->future_epg_days = $future_epg_days;
	$this->age_limit = $age_limit;
        $this->archive_past_sec = $archive_past_sec;
        $this->archive_delay_sec = $archive_delay_sec;
        $this->archive_url = $archive_url;
        $this->is_protected = $is_protected;
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_number()
    { return $this->number; }

    public function get_past_epg_days()
    { return $this->past_epg_days; }

    public function get_future_epg_days()
    { return $this->future_epg_days; }

    public function get_age_limit()
    { return $this->age_limit; }
    
    public function is_protected()
    { return $this->is_protected; }
    
    public function has_archive()
    { return $this->archive_past_sec > 0; }
    
    public function get_archive_past_sec()
    { return $this->archive_past_sec; }

    public function get_archive_delay_sec()
    { return $this->archive_delay_sec; }
    
    public function get_archive_url()
    { return $this->archive_url; }
}

