<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/default_dune_plugin.php';
require_once 'lib/utils.php';

require_once 'lib/tv/tv_group_list_screen.php';
require_once 'lib/tv/tv_channel_list_screen.php';
require_once 'lib/tv/tv_favorites_screen.php';


require_once 'commpass_config.php';
require_once 'commpass_tv.php';
require_once 'commpass_setup_screen.php';
require_once 'commpass_reg_screen.php';

///////////////////////////////////////////////////////////////////////////

class CommpassPlugin extends DefaultDunePlugin
{
    public function __construct()
    {
        $this->tv = new CommpassTv();
        //$this->vod = new DemoVod();

        $tv_folder_views = $this->get_tv_folder_views();

        $this->add_screen(new TvGroupListScreen($this->tv,
                CommpassConfig::GET_TV_GROUP_LIST_FOLDER_VIEWS()));
        $this->add_screen(new TvChannelListScreen($this->tv,
                CommpassConfig::GET_TV_CHANNEL_LIST_FOLDER_VIEWS()));
		$this->add_screen(new TvFavoritesScreen($this->tv,
                CommpassConfig::GET_TV_CHANNEL_LIST_FOLDER_VIEWS()));

        $this->add_screen(new CommpassSetupScreen());
        //$this->add_screen(new VodFavoritesScreen($this->vod));
        //$this->add_screen(new DemoVodCategoryListScreen());
        //$this->add_screen(new DemoVodListScreen($this->vod));
        //$this->add_screen(new VodMovieScreen($this->vod));
        //$this->add_screen(new VodSeriesListScreen($this->vod));
    }

    ///////////////////////////////////////////////////////////////////////

    private function get_tv_folder_views()
    {
        return CommpassConfig::GET_TV_CHANNEL_LIST_FOLDER_VIEWS();
    }
}

