<?php

require_once 'lib/dune_exception.php';

class ShowRegistrationScreenHandler implements UserInputHandler
{

    private static $instance;

    private function __construct()
    {
    }

    static public function get_instance()
    {
	if(!isset(self::$instance))
	    self::$instance = new self();
	return self::$instance;
    }

    public function get_handler_id()
    {
        return 'show_registration_form_handler';
    }

    public function handle_user_input(&$user_input, &$plugin_cookies)
    {
        $plugin_cookies->username = (isset($user_input->username)) ? $user_input->username : null;
        $plugin_cookies->password = (isset($user_input->password)) ? $user_input->password : null;
	return ActionFactory::close_dialog_and_run(ActionFactory::open_folder());
    }

};

UserInputHandlerRegistry::get_instance()->register_handler(ShowRegistrationScreenHandler::get_instance());

class ShowRegistrationScreenException extends DuneException
{
    public function __construct()
    {
	$defs = array();
        $username = isset($plugin_cookies->username) ? $plugin_cookies->username : '';
        
        ControlFactory::add_label($defs, '', '');
        //ControlFactory::add_label($defs, '', 'Для доступа к услуге, пожалуйста');
        //ControlFactory::add_label($defs, '', 'введите Ваш логин и пароль');
        //ControlFactory::add_vgap($defs, '');
        //ControlFactory::add_label($defs, '', '');
        
        //ControlFactory::add_text_field($defs, $handler, $add_params, $name, $title, $initial_value, $numeric, $password, $has_osk, $always_active, $width)
        ControlFactory::add_text_field ($defs, null, null, 'username', 'Логин:', $username, true/*numeric*/, false, false, false, 500);
        ControlFactory::add_text_field ($defs, null, null, 'password', 'Пароль:', '', true/*numeric*/, true, false, false, 500);
        ControlFactory::add_vgap ($defs, 50);
        //ControlFactory::add_button($defs, $handler, $add_params, $name, $title, $caption, $width)
        ControlFactory::add_button ($defs, ShowRegistrationScreenHandler::get_instance(), null, 'reg_ok_button', '', 'Ok', 100);
        
	$error_action = ActionFactory::show_dialog ('Регистрация', $defs);
	parent::__construct('show registration screen', 0, $error_action, null);
    }
};

