<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/abstract_controls_screen.php';
require_once 'sshd.php';
require_once 'commpass_utils.php';

///////////////////////////////////////////////////////////////////////////

class CommpassSetupScreen extends AbstractControlsScreen
{
    const ID = 'setup';

    ///////////////////////////////////////////////////////////////////////

    public function __construct()
    {
        parent::__construct(self::ID);
    }

    public function do_get_control_defs(&$plugin_cookies)
    {
        $defs = array();

        $show_tv = isset($plugin_cookies->show_tv) ?
            $plugin_cookies->show_tv : 'yes';

        $allow_ssh = isset($plugin_cookies->allow_ssh) ?
            $plugin_cookies->allow_ssh : 'no';


        $show_ops = array();
        $show_ops['yes'] = 'Да';
        $show_ops['no'] = 'Нет';

        $this->add_combobox($defs,
            'show_tv', 'Показывать TV в главном меню:',
            $show_tv, $show_ops, 0, true);

        $this->add_combobox($defs,
            'allow_ssh', 'Разрешить удаленный доступ для техподдержки',
            $allow_ssh, $show_ops, 0, true);
	if($allow_ssh == 'yes')
	    $this->add_label($defs, '', '(IP-адрес плеера: ' . get_main_ip_address() . ')');

        return $defs;
    }

    public function get_control_defs(MediaURL $media_url, &$plugin_cookies)
    {
        return $this->do_get_control_defs($plugin_cookies);
    }

    public function handle_user_input(&$user_input, &$plugin_cookies)
    {
        hd_print('Setup: handle_user_input:');
        foreach ($user_input as $key => $value)
            hd_print("  $key => $value");

        if ($user_input->action_type === 'confirm')
        {
            $control_id = $user_input->control_id;
            $new_value = $user_input->{$control_id};
            hd_print("Setup: changing $control_id value to $new_value");

            if ($control_id === 'show_tv')
                $plugin_cookies->show_tv = $new_value;
            else if ($control_id === 'show_vod')
                $plugin_cookies->show_vod = $new_value;
	    else if ($control_id === 'allow_ssh')
	    {
		$plugin_cookies->allow_ssh = $new_value;
		if($new_value == 'yes')
		    start_sshd();
		else
		    stop_sshd();
	    }
        }

        return ActionFactory::reset_controls(
            $this->do_get_control_defs($plugin_cookies));
    }
}

