<?php

///////////////////////////////////////////
// Commpass TV utility functions
//////////////////////////////////////////

/*bool*/ function have_verimatrix()
{
    return file_exists('/firmware/lib/libvmclient.so') ? true : false;
}

// better then original get_mac_addr() (without exec of ext. binaries ifconfig, awk)
/*string*/ function get_mac_address($iface = 'eth0')
{
    $file = "/sys/class/net/$iface/address";
    if(file_exists($file))
	return trim(file_get_contents($file));
    else
	return NULL;
}

// Возвращает IP-адрес интерфейса, на который показывает дефолтный маршрут
// (у плеера может быть активно сразу несколько сетевых интерфейсов: проводной, wi-fi и т.п.)
/*string*/ function get_main_ip_address()
{
    $iface = trim(shell_exec('netstat -rn | awk \'/^0.0.0.0/{print $8}\''));
    if(preg_match('/(inet\s+addr:)(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})/', shell_exec("ifconfig $iface"), $matches))
	return $matches[2];
    else
	return 'unknown';
}

/*string*/ function get_fw_version()
{
    static $fw_version = null;
    if($fw_version != null) return $fw_version;
    if(file_exists('/firmware/config/firmware_version.txt')) 
	$fw_version = trim(file_get_contents('/firmware/config/firmware_version.txt'));
    else
	$fw_version = 'Unknown';
    return $fw_version;
}

/*string*/ function get_hw_version()
{
    static $hw_version = null;
    if($hw_version != null) return $hw_version;

    if(file_exists('/firmware/config/upgrade_product_id_prefix.txt'))
	$hw_version = trim(file_get_contents('/firmware/config/upgrade_product_id_prefix.txt'));
    else if(file_exists('/firmware/config/product_id.txt'))
	$hw_version = trim(file_get_contents('/firmware/config/product_id.txt'));
    else 
	$hw_version = 'Unknown';
    return $hw_version;
}


/*** Patched versions of utils.php functions ***/
class HttpException extends Exception {
    public function __construct($message, $code, $previous)
    {
        parent::__construct($message, $code, $previous);
    }
}

function http_get_document($url, $opts = null)
{
    $ch = curl_init();

    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_TIMEOUT, 10);
    curl_setopt($ch, CURLOPT_USERAGENT, 'DuneHD/1.0');
    curl_setopt($ch, CURLOPT_URL, $url);

    if (isset($opts))
    {
        foreach ($opts as $k => $v)
            curl_setopt($ch, $k, $v);
    }

    if(function_exists('hd_print')) hd_print("HTTP fetching '$url'...");

    $content = curl_exec($ch);
    $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
    if ($content === false)
    {
        $err_msg = "HTTP error: $http_code (" . curl_error($ch) . ')';
        if(function_exists('hd_print')) hd_print($err_msg);
        throw new HttpException($err_msg, $http_code);
    }

    if ($http_code != 200)
    {
        $err_msg = "HTTP request failed ($http_code)";
        if(function_exists('hd_print')) hd_print($err_msg);
        throw new HttpException($err_msg, $http_code);
    }

    if(function_exists('hd_print')) hd_print("HTTP OK ($http_code)");

    curl_close($ch);

    return $content;
}

function http_post_document($url, $post_data)
{
hd_print("post data:" . $post_data);
    return http_get_document($url, array
        (
        CURLOPT_POST => true,
        CURLOPT_POSTFIELDS => $post_data
    ));
}


function FormatText($width, $text)
{
    $result = array();
    $i = 0;
    $line_len = 0;
    foreach(preg_split('/\s+/', $text) as $world)
    {
        $world_len = mb_strlen($world);
        if($line_len && $world_len + $line_len > $width)
        {
            $i++;
            $line_len = 0;
        }
        if($line_len)
        {
            $result[$i] .= ' ';
            $line_len += 1;
        }
        
        $result[$i] .= $world;
        $line_len += $world_len;
    }
    return $result;
}

