<?php

/* 
 * Dune media url
 */

class Url {
    private $url;
    
    public function __construct($url)
    {
        $a = explode('|||dune_params|||', $url);
        $this->url = (count($a)) ? parse_url($a[0]) : array();
        if(count($a) > 1) $this->url['dune_params'] = $a[1];
    }
    
    public function to_string()
    {
        $scheme = isset($this->url['scheme']) ? $this->url['scheme'] . '://' : '';
        $host = isset($this->url['host']) ? $this->url['host'] : '';
        $port = isset($this->url['port']) ? ':' . $this->url['port'] : '';
        $user = isset($this->url['user']) ? $this->url['user'] : '';
        $pass = isset($this->url['pass']) ? ':' . $this->url['pass'] : '';
        $pass = ($user || $pass) ? "$pass@" : '';
        $path = isset($this->url['path']) ? $this->url['path'] : '';
        $query = isset($this->url['query']) ? '?' . $this->url['query'] : '';
        $fragment = isset($this->url['fragment']) ? '#' . $this->url['fragment'] : '';
        $dune_params = isset($this->url['dune_params']) ? '|||dune_params|||' . $this->url['dune_params'] : '';
        
        return "$scheme$user$pass$host$port$path$query$fragment$dune_params";
    }

    public function __call($name, $params)
    {
        $a = explode('_', $name, 2);
        if (count($a) == 2)
        {
            if ($a[0] == 'get')
                return (isset($this->url[$a[1]])) ? $this->url[$a[1]] : null;
            else if ($a[0] == 'set')
            {
                if (count($params) != 1)
                    throw new Exception("method $name requires one argument");
                $this->url[$a[1]] = $params[0];
                return $params[0];
            }
        }
        throw new Exception("method $name is not implemented");
    }

}

